c
c     IV Cross Section Regressions with betas and beta instruments
c        from Asset Pricing 2.f
c        and then Fama/MacBeth statistics for estimated risk premia
c 
	parameter (nob=600,nm=17,nfac=17,kx=18,nstock=6372,nall=100)

c        increase dimensions of a and b when there are more than 
c        sqrt(1000) variables in total

      dimension beta(nstock,2,kx),beta2(nall,2,kx),bans(9)
 	character statname(9)*8,mname(12)*3
	character*8 xnames(kx),yname,facnam(nfac)
        
        integer fin(nfac),iperm(nstock),nt(nstock),jperm(nstock)
      dimension x1(nstock,kx),e(nstock),ret(nob,nstock)
     1, z1(nstock,kx),y1(nstock),iops(10),v(nstock,kx),w(nstock,kx)
     &,y2(nstock),x2(nstock,kx),z2(nstock,kx),bkeep(nob,2,nfac)
      common /regout/b(60),sb(60),t(60),xbar(60),std(60),rho(60),
     1 ans(5),rhox(1770),dw,se,sr,emax,emin
     2,yans(5),eans(5),akaike,schwartz

	data statname/'    Mean','  Median','   Sigma'
     &,'  T-Stat','     MAD','Skewness'
     &,'Kurtosis',' Maximum',' Minimum'/,iops/0,0,1,0,0,5*0/
     &,mname/'Jan','Feb','Mar',
     &'Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'/
        open(5,file='Cross Section FM.in',status='old')
        read(5,514)kfac,fin
514        format(i2/17i1)
	open(6,file='Cross Section FM.out'
     &,status='unknown')
      open(11,file='Cross Section FM.dat',status='unknown')  
      open(12,file='Asset Pricing 2 betas.dat',status='unknown')  
         open(9,file='Concatenate five decades.dat'
     &,form='unformatted',status='old')          
        open(8,file='Canon Variates Regressions.dat',status='old')
        read(8,512)facnam
512	format(16x,17(a8,1x))

c
c        read betas and beta instruments
c

      n282=0
        ns=1
51    format(6x,i6,i4,3x,9f8.3)
101	continue
        read(12,51,end=100)jperm(ns),nt(ns)
     &,(beta(ns,1,ll),ll=1,kfac) 
        read(12,51,end=100)jperm(ns),nt(ns)
     &,(beta(ns,2,ll),ll=1,kfac)
         
        if(nt(ns).eq.282)then
        n282=n282+1
        do 110 mk=1,2
        do 111 ll=1,kfac
        beta2(n282,mk,ll)=beta(ns,mk,ll)
111	continue
110	continue
             endif
          ns=ns+1
        go to 101
100	continue
        ns=ns-1
        write(6,52)ns,n282,kfac,jperm(1),jperm(ns)
52        format(i4,' and ',i3,' Betas are in for ',i2,' factors',2i7)

        write(6,5511)
5511        format(/'All data linked for five decades'/
     &8x,'  Factor Candidates Included: ')
        
        kin=0
        do 25 m=1,nfac
        if(fin(m).eq.0)go to 25
        kin=kin+1
        write(6,5512)kin,facnam(m)
5512        format(15x,i2,1x,a8)        
        xnames(kin)=facnam(m)
25        continue
        xnames(kin+1)='Constant'
        write(11,5513)(xnames(llk),llk=1,kfac)
5513    format(10x,9(4x,a8))
c
c  read binary returns file prepared by "Concatenate five decades.f"
c        
       k=1
31      continue     
        do 32 j=1,nob
        ret(j,k)=-9999.
32      continue 
        read(9,end=30)iperm(k),ibeg,iend,(ret(j,k),j=ibeg,iend)
c       write(6,591)ns,iperm,ibeg,iend,ret(1),ret(iend)
        k=k+1
        go to 31
591        format(6g12.4)
30        continue
        kin=k-1
        write(6,592)kin
592        format(/'Returns read in for ',i4,' stocks'/)
         yname='Returns'     
c
c        bit loop through months to do cross-sectional IV regressions
c        for all available stocks
c
        kreg=kfac+1
        do 199 jt=38,nob,2
        iyear=1965+(jt-2)/12
        mon=mod(jt-1,12)
        n1=0
        n2=0
        do 198 k=1,kin
        if(iperm(k).ne.jperm(k))then
        write(6,5198)k,iperm(k),jperm(k)
5198        format(3i6)
        stop
        endif
        if(ret(jt,k).lt.-9998.)go to 21
        n2=n2+1
        y2(n2)=ret(jt,k)
        do 197 ll=1,kfac
        x2(n2,ll)=beta(k,2,ll)
        z2(n2,ll)=beta(k,1,ll)

5397        format(i4,5g12.4)
197        continue
c        if(n2.eq.1.or.n2.eq.957)write(6,5397)n2,y2(n2)
c     &,x2(n2,1),x2(n2,kfac),z2(n2,1),z2(n2,kfac)
21      if(ret(jt-1,k).lt.-9998.)go to 198
        n1=n1+1
        y1(n1)=ret(jt-1,k)
        do 196 ll=1,kfac
        x1(n1,ll)=beta(k,1,ll)
        z1(n1,ll)=beta(k,2,ll)
196     continue        
198	continue
c        if(iops(1).eq.0)write(6,5193)n2,kreg,nstock,kx
5193        format('N2: ',i3,', Kreg: ',i2,2i5)
c       write(6,5197)jt,mname(mon),iyear,n2
5197        format('MonNum: ',i3,1x,'(',a3,1x,i4,'), NOB: ',i4)
    
        call regiv(x2,z2,y2,v,w,e,n2,kreg,nstock,kx,iops
     &,yname,xnames,*98)
      do 73 lk=1,nfac
        bkeep(jt,2,lk)=b(lk)
73        continue
      write(11,516)jt,n2,kfac,(b(lk),lk=1,kfac)
516        format(i3,i5,i3,9g12.4)
     
        call regiv(x1,z1,y1,v,w,e,n1,kreg,nstock,kx,iops
     &,yname,xnames,*98)
      do 74 lk=1,nfac
        bkeep(jt,1,lk)=b(lk)
74        continue
      write(11,516)jt-1,n1,kfac,(b(lk),lk=1,kfac)
             go to 97
98        continue
	write(6,599)jt
599	format('In month ',i3,', Regression Error')
       stop
       
97       iops(1)=1
        iops(6)=0
199	continue        
      write(6,517)statname
517        format(8x,' NOB',2x,9(4x,a8))

c
c        fama.MacBeth stats
c
       
        do 76 lk=1,kfac
        ntotal=0

        do 78 j=38,nob,2
        do 77 mk=1,2
        ntotal=ntotal+1
        y1(ntotal)=bkeep(j,mk,lk)
77        CONTINUE
78        continue

        call statsplus(y1,ntotal,bans)
        write(6,576)xnames(lk),ntotal,bans
576        format(a8,i4,2x,9f12.5)
76        continue
1000	continue
        print *,'stopped'
	stop

	end

c  Instrumental Variables Regression
c
c	The formulas are on pages 371-373 of Green, 4th edition
c
c  program now does up to 60 variables.  larger program is possible.
c  see rroll for method to compile this larger program
c  the following fortran statement will do the regression.
c         call regiv(x,z,y,v,w,e,n,k,nn,kk,iops,yname,xnames,*j)
      subroutine regiv(x,z,y,v,w,e,n,k,nn,kk,iops,yname,xnames,*)
c
c	NOTE: If subroutine reg is called in the same program, some subroutines will be redundant
c
c  x is a (nn x kk) matrix of independent variables
c  z is a (nn x kk) matrix of instrumental variables 
c	(some columns of z can be the same as x, if z=x, OLS is produced)
c  y is vector of dependent variable.  e is vector of residuals
c  n is number of observations, k is number of variables.
c  v is (n x k) work matrix.  a column of 1's is added to v(,k)
c  w is (n x k) work matrix.  a column of 1's is added to w(,k)
c  the first k - 1 variables in x and z are used in the regression
c  if x and v are input the same argument, x must contain an extra columm
c  if z and w are input the same argument, z must contain an extra column
c  if x'z or z'x is singular, return is to statement j, which must be a label in calling program
c	in this case, all the b coeffients common/regout have the values -999999.
c  iops is vector of options
c  iops(1) ne 0 suppresses all printed output
c  iops(2) ne 0 prints table of residuals
c  iops(3) ne 0 does extended residual analysis
c  iops(4) is not used
c  iops(5) ne 0 gives correlation matrix of ind. variables
c  iops(6) ne 0 gives listing of input variables
c  internal output is obtained in the common block 'regout'
      dimension iops(10), x(nn,kk),z(nn,kk),e(n)
     1, v(n,k),w(n,k),y(n),xnames(k)
      common /regout/b(60),sb(60),t(60),xbar(60),std(60),rho(60),
     1 ans(5),rhox(1770),dw,se,sr,emax,emin
     2,yans(5),eans(5),akaike,schwartz
	character*8 xnames,yname
c  b(kk) is regression coefficient vector
c  sb(kk) is standard error vector
c  t(kk) is t statistics vector
c  xbar(kk) and std(kk) are mean and standard deviation vectors of vbls.
c  rhox is correlation coefficient matrix of ind. variables
c       this matrix is stored as lower triangle
c       i.e., r12,r13,r23,r14,r24,r34,...
c  ans(1) is mean of y
c  ans(2) is std. dev. of y
c  ans(3) is r**2 (adjusted)
c  ans(4) is std. error of estimate
c  ans(5) is f statistic for the regresssion
c  dw is durbin-watson statistic
c  se is std. dev. of residuals
c  sr is studentized range of residual distribution
c  emax is maximum residual
c  emin is minimum residual
c  xnames is vector (a8) of explanatory variable names
c  yname is (a8) name of dependent variable
c  yans and eans are stats vectors for dependent variable and residuals
c	1	mean
c	2	standard deviation
c	3	mean absolute deviation
c	4	skewness
c	5	excess kurtosis
c  akaike is the log of the Akaike Criterion
c  schwartz is the log of the Schwartz Criterion
c

      
      m=k
      ka=k-1
      io=1
    3 format(/'Instrumental Variables Regression'/
     &9h Variable,4x,4hMean,5x,
     &8hStandard,'     Corr.',2x,
     &10hRegression,6x,5hT    ,2x,10h Standard 
     &/6h    x ,16x,9hDeviation,
     &1x,8h  x vs y,2x,11hCoefficient,3x,5hValue,4x,11h   Error    /1x)
    4 format(1h ,a8,1x,2g11.3,f8.4,1x,2g12.4,g11.3)
  544 format(1h ,a8,1x,2g11.3,2g12.4)
    5 format(1h /10hDependent ,23x,'Skewness     Kurtosis')
6     format(10hIntercept ,31x,2g12.4,g11.3)
56    format(1x/1x,'     Adjusted R-Square:',
     1g12.5,3x,'Std. Error of Estimate:',g12.5/
     &1x,          '  Ln(Akaike Criterion):',g12.5
     &,3x,     'Ln(Schwartz Criterion):',g12.5/
     & ' Regression F(',i2,'/',i5,'):',g12.5,14x,'Sample Size:',i5)
   10 format(36i2)
11    format(1h ,15x//29x,18hTable of Residuals/1x//
     &1x,2(12h    Obs. No.,
     15x,7hy value,2x,10h  Residual,2x))
   12 format(1h /2(1x,i7,5x,g15.5,g11.4))
   13 format(1h /15x,'Analysis of Residuals'//
     &1x,'   Durbin     Standard    Studentized  Mean Absolute'/
     &1x,'   Watson     Deviation      Range       Deviation'/
     &1x,4g13.5/
     &1x,'  Maximum      Minimum     Skewness      Kurtosis'/
     &1x,4g13.5)
      call easyIV
     &(x,z,y,e,v,w,n,k,nn,kk,b,sb,t,rho,rhox,ans,xbar,std
     &,deterztx,deterxtz,*99)
	call stats(y,n,yans)
	call stats(e,n,eans)
	xnnn=n
	sslog=log(((xnnn-1.)/xnnn)*eans(2)**2)
	akaike=sslog+2.*k/n
	schwartz=sslog+k*log(xnnn)/n
      if(iops(1).ne.0)go to 144
      write(6,3)
      do 115 j=1,ka
  115 write(6,4)xnames(j),xbar(j),std(j),rho(j),b(j),t(j),sb(j)
      fstat=ans(5)
      ndfn=k-1
      ndfd=n-k
      write(6,6)b(k),t(k),sb(k)
      write(6,5)
      write(6,544)yname,ans(1),ans(2),yans(4),yans(5)
      write(6,56)ans(3),ans(4),akaike,schwartz,ndfn,ndfd,fstat,n
  144 continue
      if(iops(5).eq.0)go to 30
      kr=0
      ka=k-1
      kb=k-2
      if(kb.le.0)go to 30
      do 31 i=2,ka
      li=i-1
      do 32 ii=1,li
      kr=kr+1
   32 rhox(kr)=(rhox(kr)/n-xbar(i)*xbar(ii))/(std(i)*std(ii))
   31 continue
      if(iops(1).ne.0)go to 30
      write(6,14)(xnames(i),i=1,kb)
   14 format(/13x,'Correlation coefficients of independent variables'/
     1/(12x,10(a8,2x)))
      ie=0
      do 33 i=1,kb
      klx=i+1
      ib=ie+1
      ie=ie+i
   33 write(6,15)xnames(klx),(rhox(kr),kr=ib,ie)
   15 format(2x,a8,10f10.5/(10x,10f10.5))
   30 continue
      if(iops(1).ne.0)go to 143
      if(iops(6).eq.0)go to 40
      call wrxIV(v,w,y,n,k)
   40 continue
      if(iops(2).eq.0)go to 143
      write(6,11)
  142 write(6,12)(j,y(j),e(j),j=1,n)
  143 continue
      if(iops(3).eq.0)go to 999
c	calculate durbin-watson and other residual statistics
      emax=e(1)
      suma=0.
      emin=e(1)
      sumb=e(1)**2
      sumc=abs(e(1))
      do 150 i=2,n
      if(e(i).gt.emax)emax=e(i)
      if(e(i).lt.emin)emin=e(i)
      sumc=sumc+abs(e(i))
      suma=suma+(e(i)-e(i-1))**2
  150 sumb=sumb+e(i)**2
      sumc=sumc/n
      dw=suma/sumb
      se=sqrt(sumb/n)
      sr=(emax-emin)/se
      if(iops(1).eq.0)write(6,13)dw,se,sr,sumc,emax,emin,eans(4),eans(5)
  999 continue
      if(iops(1).eq.0)write(6,5999)
5999  format(1h )
      return
99	continue
	if(iops(6).ne.0.and.iops(1).eq.0)call wrxIV(v,w,y,n,k)
	if(iops(1).eq.0)write(6,599)deterztx,deterxtz
599	format(1h ,2x,'Singularity! |ztx| = ',g14.4,', |xtz| = ',g14.4
     1,'.  Regression not computed')
	do 598 mmk=1,k
	b(mmk)=-999999.
598	continue
	return 1
      end


      subroutine wrxIV(v,w,y,n,k)
      dimension v(n,k),w(n,k),y(n)
      ka=k-1
49     format(1h //2x,'Input Matrix'//)
   50 format(1h /1x,8x,'y',7x,'x:',i5,5i11/
     &(19x,i5,5i11))
501	format(17x,'z:',i5,5i11/(19x,i5,5i11))
   51 format(1h ,1x,i4,g11.3,3x,6g11.3/
     &(19x,6g11.3))
511   format(1h ,17x,6g11.3/
     &(18x,6g11.3))
   52 format(1h ,1x/)
      write(6,52)
      write(6,52)
      write(6,49)
    1 write(6,50)(i,i=1,ka)
      write(6,501)(i,i=1,ka)
      do 2 j=1,n
      write(6,51)j,y(j),(w(j,l),l=1,ka)
2     write(6,511)(v(j,l),l=1,ka)
      return
      end


        subroutine stats(x,n,ans)
c
c  mean, standard deviation, mad, skewness, excess kurtosis,
c	given in output vector a(5), 1,...,5, respectively
c
      dimension x(1),ans(5)
      double precision sx,sx2,sx3,sx4,sm,sigx
	sm=0.d0
      sx=0.d0
      sx2=0.d0
      sx3=0.d0
      sx4=0.d0
      do 1 l=1,n
      sx=sx+x(l)
1     continue
      sx=sx/n
	ans(1)=sx
        do 2 l=1,n
        dx=x(l)-sx
	sm=sm+abs(dx)
      sx2=sx2+dx**2
      sx3=sx3+dx**3
      sx4=sx4+dx**4
2	continue
      sx2=sx2/(n-1)
	sigx=dsqrt(sx2)
	ans(2)=sigx
	ans(3)=sm/n
	ans(4)=(sx3/(n-1))/sigx**3.
	ans(5)=(sx4/(n-1))/sigx**4-3.
      return
      end
      subroutine gmprdIV(a,b,r,n,m,l)
      double precision a(n,m),b(m,l),s,r(n,l)
      do 1 j=1,n
      do 1 k=1,l
      s=0.d0
      do 3 i=1,m
    3 s=s+a(j,i)*b(i,k)
    1 r(j,k)=s
      return
      end
      subroutine tprd(a,b,r,n,m,msa,msb,l)
	dimension a(1),b(1)
        double precision r(1)
c
c        special case for diagonal by diagonal
c
      ms=msa*10+msb
      if(ms-22)30,10,30
   10 do 20 i=1,n
   20 r(i)=a(i)*b(i)
      return
c
c        multiply transpose of a by b
c
   30 ir=1
      do 90 k=1,l
      do 90 j=1,m
      r(ir)=0.d0
      do 80 i=1,n
      if(ms) 40,60,40
   40 call loc(i,j,ia,n,m,msa)
      call loc(i,k,ib,n,l,msb)
      if(ia) 50,80,50
   50 if(ib) 70,80,70
   60 ia=n*(j-1)+i
      ib=n*(k-1)+i
   70 r(ir)=r(ir)+a(ia)*b(ib)
   80 continue
   90 ir=ir+1
      return
      end
      subroutine loc(i,j,ir,n,m,ms)
c
        kdum=m
      ix=i
      jx=j
      if(ms-1) 10,20,30
   10 irx=n*(jx-1)+ix
      go to 36
   20 if(ix-jx) 22,24,24
   22 irx=ix+(jx*jx-jx)/2
      go to 36
   24 irx=jx+(ix*ix-ix)/2
      go to 36
   30 irx=0
      if(ix-jx) 36,32,36
   32 irx=ix
   36 ir=irx
      return
      end
      subroutine mata(a,r,n,m,ms)
      dimension a(n,m)
      double precision r(m,m),s
      kdum=ms
      do 1 j=1,m
      do 2 l=1,j
      s=0.d0
      do 3 i=1,n
    3 s=s+a(i,j)*a(i,l)
      r(l,j)=s
    2 r(j,l)=s
    1 continue
      return
      end
      subroutine minv(a,n,d,l,m)
      double precision a(1),l(1),m(1),d,biga,hold
      d=1.0d0
      nk=-n
      do 80 k=1,n
      nk=nk+n
      l(k)=k
      m(k)=k
      kk=nk+k
      biga=a(kk)
      do 20 j=k,n
      iz=n*(j-1)
      do 20 i=k,n
      ij=iz+i
   10 if(dabs(biga)-dabs(a(ij))) 15,20,20
   15 biga=a(ij)
      l(k)=i
      m(k)=j
   20 continue
c
c        interchange rows
c
      j=l(k)
      if(j-k) 35,35,25
   25 ki=k-n
      do 30 i=1,n
      ki=ki+n
      hold=-a(ki)
      ji=ki-k+j
      a(ki)=a(ji)
   30 a(ji) =hold
c
c        interchange columns
c
   35 i=m(k)
      if(i-k) 45,45,38
   38 jp=n*(i-1)
      do 40 j=1,n
      jk=nk+j
      ji=jp+j
      hold=-a(jk)
      a(jk)=a(ji)
   40 a(ji) =hold
c
c        divide column by minus pivot (value of pivot element is
c        contained in biga)
c
   45 if(biga) 48,46,48
   46 d=0.0d0
      return
   48 do 55 i=1,n
      if(i-k) 50,55,50
   50 ik=nk+i
      a(ik)=a(ik)/(-biga)
   55 continue
c
c        reduce matrix
c
      do 65 i=1,n
      ik=nk+i
      hold=a(ik)
      ij=i-n
      do 65 j=1,n
      ij=ij+n
      if(i-k) 60,65,60
   60 if(j-k) 62,65,62
   62 kj=ij-i+k
      a(ij)=hold*a(kj)+a(ij)
   65 continue
c
c        divide row by pivot
c
      kj=k-n
      do 75 j=1,n
      kj=kj+n
      if(j-k) 70,75,70
   70 a(kj)=a(kj)/biga
   75 continue
c
c        product of pivots
c
      d=d*biga
c
c        replace pivot by reciprocal
c
      a(kk)=1.0d0/biga
   80 continue
c
c        final row and column interchange
c
      k=n
  100 k=(k-1)
      if(k) 150,150,105
  105 i=l(k)
      if(i-k) 120,120,108
  108 jq=n*(k-1)
      jr=n*(i-1)
      do 110 j=1,n
      jk=jq+j
      hold=a(jk)
      ji=jr+j
      a(jk)=-a(ji)
  110 a(ji) =hold
  120 j=m(k)
      if(j-k) 100,100,125
  125 ki=k-n
      do 130 i=1,n
      ki=ki+n
      hold=a(ki)
      ji=ki-k+j
      a(ki)=-a(ji)
  130 a(ji) =hold
      go to 100
  150 return
      end
	subroutine wtprd(xtx,k,kk,name)
	real*8 xtx(k,kk)
	character*8 name
	write(6,51)name
51	format(a8)
	do 1 l=1,k
	write(6,50)(xtx(l,i),i=1,kk)
50	format(3g12.4)
1	continue
	return
	end
      subroutine easyIV
     &(x,z,y,e,v,w,n,k,nn,kk,b,sb,t,rho,rhox,ans,xbar,sx
     &,deterztx,deterxtz,*)
      dimension e(1),z(nn,kk),x(nn,kk),y(nn),b(1),sb(1),t(1),ans(1)
     1,rhox(1),rho(k),xbar(1),sx(1),v(n,k),w(n,k)
      double precision det,ztx(3600),xtz(3600),ztz(3600),ztemp(3600)
     &,zcov(3600),xtx(3600),zty(60),xty(60),igarb(60),ixty(60),bd(60)
     &,det1,det2
c        write(6,5992)n,k,nn,kk,y(1),x(1,1),x(1,k-1),z(1,1),z(1,k-1)
c     &,y(n),x(n,1),x(n,k-1),z(n,1),z(n,k-1)
5992	format(2i4,2i5/(5g12.4))
c       write(6,5995)n,k
        
      ka=k-1
      do 1 l=1,ka
      do 1 i=1,n
	v(i,l)=z(i,l)
    1 w(i,l)=x(i,l)
      do 3 i=1,n
	v(i,k)=1.
    3 w(i,k)=1.


      call tprd(v,w,ztx,n,k,0,0,k)
c	call wtprd(ztx,k,k,'ztx     ')
      call tprd(w,v,xtz,n,k,0,0,k)
c	call wtprd(xtz,k,k,'xtz     ')

      call mata(w,xtx,n,k,0)
      call mata(v,ztz,n,k,0)
c
c	means, sigmas, and covariances of the x's
c
      kr=0
      kb=k-2
      do 8 l=1,kb
      jl=l*k
      do 9 ll=1,l
      kr=kr+1
      ml=jl+ll
    9 rhox(kr)=xtx(ml)
    8 continue
      do 2 l=1,ka
      lap=k*l
      xbar(l)=xtx(lap)/n
      ll=(l-1)*k+l
    2 sx(l)=sqrt(xtx(ll)/n-xbar(l)**2)
c
c	matrix inversion of z'x and x'z
c
      call minv(ztx,k,det1,igarb,ixty)
c	call wtprd(ztx,k,k,'ztx-1   ')

  750 format(1h ,2x,6e12.3,2i6)
      call minv(xtz,k,det2,igarb,ixty)
c	call wtprd(xtz,k,k,'xtz-1   ')
      if(dabs(det1).le.1.d-12.or.dabs(det2).le.1.d-12)go to 99

c
c	matrix multiplications
c
c	z'y
      call tprd(v,y,zty,n,k,0,0,1)
c	call wtprd(zty,k,1,'zty     ')
c	x'y
	call tprd(w,y,xty,n,k,0,0,1)
c	call wtprd(xty,k,1,'xty     ')
c	coefficients
      call gmprdIV(ztx,zty,bd,k,k,1)
	do 18 md=1,k
	b(md)=bd(md)
18	continue
c	[(z'x)-1]*z'z
	call gmprdIV(ztx,ztz,ztemp,k,k,k)
c	[(z'x)-1]*(z'z)*[(x'z)-1]
	call gmprdIV(ztemp,xtz,zcov,k,k,k)
c	zcov now has covariances (divided by sigma of residuals)
c      call wtprd(zcov,k,k,'zcov    ')
      sum=0.
      sy=0.
      ybb=zty(k)/n
      do 4 i=1,n
      sy=sy+(y(i)-ybb)**2
      xjunk=y(i)-b(k)
      e(i)=xjunk
      do 5 l=1,ka
    5 e(i)=e(i)-b(l)*w(i,l)
   51 format(1h ,2x,4i5)
    4 sum=sum+e(i)**2
      ssr=sy-sum
      sr=sum/(n-k)
      do 6 l=1,k
      ll=(l-1)*k+l
      sb(l)=sqrt(sr*zcov(ll))
    6 t(l)=b(l)/sb(l)
      ans(1)=ybb
      ans(3)=1.-sr/(sy/(n-1))
      ans(2)=sqrt(sy/n)
      ans(4)=sqrt(sr)
      ans(5)=(ssr/(k-1))/sr
      do 7 l=1,ka
    7 rho(l)=(xty(l)/n-ans(1)*xbar(l))/(ans(2)*sx(l))
      return
   99 continue
c	write(6,599)det1,det2
599	format(2g12.4)
     
	deterztx=det1
	deterxtz=det2
	return 1
      end

c
        subroutine statsplus(x,n,ans)
c
c	mean, standard deviation, t-stat, mad, skewness, excess kurtosis,
c	maximum, minimum, and median
c	given in output vector ans(9), 1,...,9, respectively
c
      dimension x(1),ans(9)
	character*8 statname(9)

      double precision sx,sx2,sx3,sx4,sm,sigx
      common /sortstat/a(200001)
	external movestat,compstat
	data statname/'    Mean','  Median','   Sigma'
     &,'  T-Stat','     MAD','Skewness'
     &,'Kurtosis',' Maximum',' Minimum'/

	sm=0.d0
      sx=0.d0
      sx2=0.d0
      sx3=0.d0
      sx4=0.d0
	smax=x(1)
	smin=x(1)
      do 1 l=1,n
      sx=sx+x(l)
	if(x(l).gt.smax)smax=x(l)
	if(x(l).lt.smin)smin=x(l)
1     continue
      sx=sx/n
	ans(1)=sx
        do 2 l=1,n
        dx=x(l)-sx
	sm=sm+abs(dx)
      sx2=sx2+dx**2
      sx3=sx3+dx**3
      sx4=sx4+dx**4
2	continue
      sx2=sx2/(n-1)
	sigx=dsqrt(sx2)
	ans(3)=sigx
	xnn=n
	ans(4)=ans(1)/(ans(3)/sqrt(xnn))
	ans(5)=sm/n
	ans(6)=(sx3/(n-1))/sigx**3.
	ans(7)=(sx4/(n-1))/sigx**4-3.
	ans(8)=smax
	ans(9)=smin
	do 3 j=1,n
	a(j)=x(j)
3	continue
		call tsort3(movestat,compstat,n)
		if(mod(n,2).eq.0)then
			ln=n/2
			ans(2)=(a(ln)+a(ln+1))/2.
			return
		else
			ln=n/2+1
			ans(2)=a(ln)
			return
		endif
      end

      subroutine movestat(n,m)
      common /sortstat/a(200001)
      a(m)=a(n)
      return
      end
      function compstat(n,m)
      common /sortstat/a(200001)
      compstat=a(n)-a(m)
      return
      end

   	
c  following subroutine and function will sort one array of length nnn
c  in ascending order.  external statements must be used in calling
c  program with the names chosen for move and comp passed to tsort3.
c        warning    warning     warning
c   tsort3 destroys the nnn+1 st element of the sorted array (a).
c      keep this element blank.
c     subroutine move(n,m)
c     common /sorts/a(1001)
c     a(m)=a(n)
c     return
c     end
c     function comp(n,m)
c     common /sorts/a(1001)
c     comp=a(n)-a(m)
c     return
c     end
c  more complicated sorts can be accomplished simply by altering
c  the programs move and comp.  for example, to carry along an
c  array z which could be a name associated with the sorted number,
c  one would simply put the following statement in move after a(m)=a(n)
c
c      z(m)=z(n)
c
c  sorting can also be accomplished on more complex criteria than
c  simple ariithmetic value.  for example, if element a(n) should lie
c  above element a(m) iff a(n)=.true. and a(m)=.false. change the
c  arithmetic compare statement in comp to
c
c      comp=-1
c      if((a(n).eq..true.).and.(a(m).eq..false.))comp=1
c
c
c
       subroutine tsort3(move,comp,nnn)
      n=nnn
      nh=n/2
      n1=n+1
      if(n-2)60,55,100
  100 if(mod(n,2))10,1,10
    1 if(comp(n,nh))2,2,3
    3 call move(n,n1)
      call move(nh,n)
      call move(n1,nh)
    2 nh=nh-1
   10 ns=nh*2
      if(comp(ns,ns+1))4,5,5
    4 ns=ns+1
    5 if(comp(nh,ns))6,30,30
    6 nht=ns
      call move(nh,n1)
      call move(ns,nh)
    7 ns=nht*2
      if(ns-n)8,12,29
    8 if(comp(ns,ns+1))11,12,12
   11 ns=ns+1
   12 if(comp(n1,ns))22,29,29
   22 call move(ns,nht)
      nht=ns
      go to 7
   29 call move(n1,nht)
   30 nh=nh-1
      if(nh)10,31,10
   31 no=n
      go to 50
   32 call move(no,n1)
      call move(1,no)
      no=no-1
      if(comp(2,3))34,34,37
   34 call move(3,1)
      nos=3
      ns=6
      go to 40
   37 call move(2,1)
      nos=2
      ns=4
   40 if(ns-no)42,43,49
   42 if(comp(ns,ns+1))45,43,43
   45 ns=ns+1
   43 if(comp(n1,ns))44,49,49
   44 call move(ns,nos)
      nos=ns
      ns=2*nos
      go to 40
   49 call move(n1,nos)
   50 if(no-3)54,54,32
   54 call move(3,n1)
      call move(1,3)
      call move(n1,1)
   55 if(comp(1,2))60,60,56
   56 call move(1,n1)
      call move(2,1)
      call move(n1,2)
   60 return
      end




